"""Allow to register multiple booths per participation

Revision ID: 006eb72b638d
Revises: 7be14b5074f3
Create Date: 2020-07-19 19:31:04.262881

"""
from alembic import op
import sqlalchemy as sa
import enum
from sqlalchemy.dialects import mysql
from sqlalchemy import orm, Float, Integer, Enum, String, UnicodeText
from sqlalchemy.ext.declarative import declarative_base

# revision identifiers, used by Alembic.
revision = '006eb72b638d'
down_revision = '7be14b5074f3'
branch_labels = None
depends_on = None

# Models for data migration
Base = declarative_base()


class BoothSize(enum.Enum):
    SMALL = 0
    LARGE = 1


class FairDays(enum.Enum):
    FIRST = 1
    SECOND = 2
    BOTH = 3


class TableType(enum.Enum):
    LOW = 0
    HIGH = 1


class Participation(Base):
    __tablename__ = 'participations'

    id = sa.Column(Integer, primary_key=True)
    message = sa.Column(UnicodeText)
    # Total price for all booked booths!
    booth_price = sa.Column(Float, nullable=False)

    # old fields
    booth_id = sa.Column(Integer, sa.ForeignKey('booth_options.id'), nullable=False)
    day = sa.Column(Enum(FairDays), nullable=False)
    booth_size = sa.Column(Enum(BoothSize), nullable=False)
    table_type = sa.Column(Enum(TableType), nullable=False)
    booth_location = sa.Column(String(100), nullable=True)

    booth_option = orm.relationship('BoothOption')


class BoothOption(Base):
    __tablename__ = 'booth_options'

    id = sa.Column(Integer, primary_key=True)
    booth_category = sa.Column(String(1), nullable=False)
    price_one_day_small = sa.Column(Float, nullable=False)
    price_two_days_small = sa.Column(Float, nullable=False)
    price_one_day_large = sa.Column(Float, nullable=False)
    price_two_days_large = sa.Column(Float, nullable=False)

    def get_booth_price(self, day, size):
        """Returns the price of the booth with the given day(s) and size (as enums)."""
        if day == FairDays.FIRST or day == FairDays.SECOND:
            if size == BoothSize.SMALL:
                return self.price_one_day_small
            else:
                return self.price_one_day_large
        elif day == FairDays.BOTH:
            if size == BoothSize.SMALL:
                return self.price_two_days_small
            else:
                return self.price_two_days_large
        raise ValueError


class BoothBooked(Base):
    __tablename__ = 'booths_booked'

    id = sa.Column(Integer, primary_key=True)
    participation_id = sa.Column(Integer, sa.ForeignKey('participations.id'), nullable=False)
    booth_id = sa.Column(Integer, sa.ForeignKey('booth_options.id'), nullable=False)
    day = sa.Column(Enum(FairDays), nullable=False)
    booth_size = sa.Column(Enum(BoothSize), nullable=False)
    table_type = sa.Column(Enum(TableType), nullable=False)
    message = sa.Column(UnicodeText)
    booth_location = sa.Column(String(100), nullable=True)


# Schema and Data Migrations

def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('booths_booked',
                    sa.Column('id', sa.Integer(), nullable=False),
                    sa.Column('participation_id', sa.Integer(), nullable=False),
                    sa.Column('booth_id', sa.Integer(), nullable=False),
                    sa.Column('day', sa.Enum('FIRST', 'SECOND', 'BOTH', name='fairdays'), nullable=False),
                    sa.Column('booth_size', sa.Enum('SMALL', 'LARGE', name='boothsize'), nullable=False),
                    sa.Column('table_type', sa.Enum('LOW', 'HIGH', name='tabletype'), nullable=False),
                    sa.Column('message', sa.UnicodeText(), nullable=True),
                    sa.Column('booth_location', sa.String(length=100), nullable=True),
                    sa.ForeignKeyConstraint(['booth_id'], ['booth_options.id'], ),
                    sa.ForeignKeyConstraint(['participation_id'], ['participations.id'], ),
                    sa.PrimaryKeyConstraint('id')
                    )
    op.add_column('participations', sa.Column('booth_price', sa.Float(), nullable=False))

    # Migrate existing data
    bind = op.get_bind()
    session = orm.Session(bind=bind)

    for participation in session.query(Participation):
        booth_booked = BoothBooked()
        booth_booked.participation_id = participation.id
        booth_booked.booth_id = participation.booth_id
        booth_booked.booth_location = participation.booth_location
        booth_booked.booth_size = participation.booth_size
        booth_booked.table_type = participation.table_type
        booth_booked.day = participation.day

        participation.booth_price = participation.booth_option.get_booth_price(booth_booked.day,
                                                                               booth_booked.booth_size)

        session.add(booth_booked)
        session.add(participation)

    session.commit()

    # Clean up database schema
    op.drop_constraint('participations_ibfk_1', 'participations', type_='foreignkey')
    op.drop_column('participations', 'table_type')
    op.drop_column('participations', 'booth_id')
    op.drop_column('participations', 'day')
    op.drop_column('participations', 'booth_size')
    op.drop_column('participations', 'booth_location')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('participations', sa.Column('booth_location', mysql.VARCHAR(length=100), nullable=True))
    op.add_column('participations', sa.Column('booth_size', mysql.ENUM('SMALL', 'LARGE'), nullable=False))
    op.add_column('participations', sa.Column('day', mysql.ENUM('FIRST', 'SECOND', 'BOTH'), nullable=False))
    op.add_column('participations', sa.Column('booth_id', mysql.INTEGER(display_width=11),
                                              autoincrement=False, nullable=False))
    op.add_column('participations', sa.Column('table_type', mysql.ENUM('LOW', 'HIGH'), nullable=False))
    op.create_foreign_key('participations_ibfk_1', 'participations', 'booth_options', ['booth_id'], ['id'])

    # WARNING! Data migration is not revertible!

    op.drop_column('participations', 'booth_price')
    op.drop_table('booths_booked')
    # ### end Alembic commands ###
